#include "debug.h"
#include "main.h"
#include "stdio.h"
#include "usart.h"
#include "stdarg.h"


void debug_tx_cb(void);

static uint8_t debug_buf[256] __attribute__((aligned(32)));

/*
osSemaphoreDef(dbg_mutex);
osSemaphoreId g_dbg_mutex;
void debug_init(void)
{
    g_dbg_mutex = osSemaphoreNew(1, 1, osSemaphore(dbg_mutex));
}
*/

void DBG_log(const char * format, ...)
{
    int len;
    va_list arglist;

    va_start(arglist, format);
    len = vsprintf((char*)debug_buf, format, arglist);
    va_end(arglist);

/*    
    HINWEIS: Cache-Konsistenzprobleme
    Wenn D-Cache verwendet wird und die Daten über DMA gesendet werden, ist es wichtig zu beachten, 
	dass die Daten im D-Cache vor dem Senden in den SRAM zurückgeschrieben werden.
    SCB_CleanDCache_by_Addr : löscht die angegebenen D-Cache-Daten und schreibt die D-Cache-Daten 
	für DMA-Sendungen zurück in den SRAM.
    SCB_InvalidateDCache_by_Addr : Ungültigmachen der angegebenen D-Cache-Daten, 
	die aus dem SRAM in den D-Cache zurückgeladen werden müssen, verwendet für DMA-Empfang.
*/

  //  SCB_CleanDCache_by_Addr((uint32_t *)debug_buf, len);

    HAL_UART_Transmit(&huart1, debug_buf, len,100);
}

/*
void debug_tx_cb(void)
{
    osSemaphoreRelease(g_dbg_mutex);
}

*/